///bs:-input,console
#include<bits\stdc++.h>
#define _ << ' ' <<
 
using namespace std;
 
const int MAXN = 2000, INF = 1e9, CNT_DIR = 8;
 
int c[MAXN][MAXN];
 
int xm, ym, xa, ya;
 
int n, m;
 
int dst(int x1, int y1, int x2, int y2) {
	int dx = x1 - x2, dy = y1 - y2;
	return dx * dx + dy * dy;
}
 
int getDirection(int x, int y) {
	int dx = xm - x, dy = ym - y;
	if (abs(dx) == abs(dy)) {
		if (dx < 0 && dy > 0) return 1;
		if (dx > 0 && dy > 0) return 3;
		if (dx > 0 && dy < 0) return 5;
		return 7;
	}
	if (abs(dy) > abs(dx)) {
		if (dy > 0) return 2;
		return 6;
	}
	if (dx > 0) return 4;
	return 0;
}
 
int revDir(int d) {
	return (d + CNT_DIR / 2) % CNT_DIR;
}
 
bool check() {
	vector<pair<int, int> > rev;
	for (int x = 0; x < n; x++) {
		for (int y = 0; y < m; y++) {
			if (x == xm && y == ym) continue;
			int d = getDirection(x, y);
			if (d != c[x][y]) {
				if (d != revDir(c[x][y])) return 0;
				rev.push_back({x, y});
			}
		}
	}
	for (xa = 0; xa < n; xa++) {
		bool fl = 1;
		ya = -1;
		for (auto [x, y] : rev) {
			if (x == xa) continue;
			if (ya == -1) ya = y;
			if (ya != y) fl = 0;
		}
		if (fl) {
			if (ya == -1) ya = ym;
			return 1;
		}
	}
	return 0;
}
 
void out() {
	cout << xm + 1 << ' ' << ym + 1 << endl;
	cout << xa + 1 << ' ' << ya + 1 << endl;	
	exit(0);
}
 
void slowSolution() {
	for (xm = 0; xm < n; xm++) {
		for (ym = 0; ym < m; ym++) {
			if (check()) {
				out();
				return;
			}
		}
	}
}
 
int cntRightDiag[MAXN * 2], cntLeftDiag[MAXN * 2];
 
pair<int, int> crossDiag(int iLeftDiag, int iRightDiag) {
	int j2 = iLeftDiag + iRightDiag - n + 1;
	if (j2 % 2 == 1) return {-1, -1};
	int j = j2 / 2;
	int i = iRightDiag - j;
	return {i, j};
}
 
void checkLeftDiag() {
	for (xm = 0; xm < 2; xm++) {
		for (ym = 0; ym < 2; ym++) {
			if (xm == 1 && ym == 1) continue;
			if (check()) {
				out();
				return;
			}
		}
	}
 
	for (xm = n - 2; xm < n; xm++) {
		for (ym = m - 2; ym < m; ym++) {
			if (xm == n - 2 && ym == m - 2) continue;
			if (check()) {
				out();
				return;
			}
		}
	}
}
 
void checkRightDiad() {
	for (xm = 0; xm < 2; xm++) {
		for (ym = m - 2; ym < m; ym++) {
			if (xm == 1 && ym == m - 2) continue;
			if (check()) {
				out();
				return;
			}
		}
	}
 
	for (xm = n - 2; xm < n; xm++) {
		for (ym = 0; ym < 2; ym++) {
			if (xm == n - 2 && ym == 1) continue;
			if (check()) {
				out();
				return;
			}
		}
	}
 
}
 
void fastSolution() {
 
	vector<pair<int, int> > diag;
 
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (c[i][j] % 2 == 1) {
				diag.push_back({i, j});
				int leftDiagIndex = j - i + n - 1;
				int rightDiagIndex = i + j;
 
				cntLeftDiag[leftDiagIndex]++;
				cntRightDiag[rightDiagIndex]++;
			}
		}
	}
	int iLeftMax = 0, iRightMax = 0;
	for (int i = 0; i < n + m - 1; i++) {
		if (cntLeftDiag[i] > cntLeftDiag[iLeftMax]) iLeftMax = i;
	}
 
	for (int i = 0; i < n + m - 1; i++) {
		if (cntRightDiag[i] > cntRightDiag[iRightMax]) iRightMax = i;
	}
 
	if (cntLeftDiag[iLeftMax] > 1 && cntRightDiag[iRightMax] > 1) {
		tie(xm, ym) = crossDiag(iLeftMax, iRightMax);
		check();
		cout << xm + 1 _ ym + 1 << '\n';
		cout << xa + 1 _ ya + 1 << '\n';
		return;
	}
	if (cntLeftDiag[iLeftMax] > 1) {
		checkLeftDiag();
	} else {
		checkRightDiad();
	}
 
}
 
int main() {

	ios_base::sync_with_stdio(0);
	cin.tie(0);
 
	cin >> n >> m;
 
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> c[i][j];
			c[i][j]--;
		}
	}
 
	if (n < 3 || m < 3) {
		slowSolution();
		return 0;
	}
 
	fastSolution();
	
	return 0;
}
