#include <bits/stdc++.h>
 
using namespace std;
 
void fast_io() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
}
 
struct node {
    int l = 0, r = 0;
    int last = -1, val = -1;
};
 
vector<node> tree(1);
 
int c;
int timer = 0;
 
inline void paint(const string& path, int c_i) {
    auto it = 0;
    for (auto i : path) {
        if (i == 'L') {
            if (!tree[it].l) {
                tree[it].l = tree.size();
                tree.emplace_back();
            }
            it = tree[it].l;
        } else {
            if (!tree[it].r) {
                tree[it].r = tree.size();
                tree.emplace_back();
            }
            it = tree[it].r;
        }
    }
    tree[it].last = timer;
    tree[it].val = c_i;
}
 
inline int get_c(const string& path) {
    pair<int, int> res = {-1, -1}; // last, val
    auto it = 0;
    for (auto i : path) {
        if (tree[it].val != -1 && tree[it].last > res.first) {
            res = {tree[it].last, tree[it].val};
        }
        if (i == 'L') {
            if (!tree[it].l) {
                tree[it].l = tree.size();
                tree.emplace_back();
            }
            if (res.second != -1) {
                res.second = (res.second + 1) % c; 
            }
            it = tree[it].l;
        } else {
            if (!tree[it].r) {
                tree[it].r = tree.size();
                tree.emplace_back();
            }
            if (res.second != -1) {
                res.second = (res.second + c - 1) % c; 
            }
            it = tree[it].r;
        }
    }
    return res.second;
}
 
signed main() {
    fast_io();
    int q, t, c_i;
    cin >> q >> c;
    string path;
    for (int i = 0; i < q; ++i) {
        ++timer; 
        cin >> t;
        if (t == 1) {
            cin >> c_i;
        }
        cin >> path;
        if (t == 1) {
            paint(path, c_i);
        } else {
            cout << get_c(path) << '\n';
        }
    }
    return 0;
}