#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n");
    bool mirror = opt<bool>("mirror");

    println(n);
    vector<pair<int, int>> pts;
    for (int i = 0; i < n; i++) {
        int x = mirror ? i - n / 2 : i;
        pts.emplace_back(i * n + 1, x * x * n + 1);
    }
    shuffle(pts.begin(), pts.end());

    for (auto &p : pts) println(p.first, p.second);

}