using namespace std;

#include <unordered_set>
#include <queue>
#include "testlib.h"

const int max_str_len = 2000'000;
typedef long long ll;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    vector<char> ex_chars;
    for (int c = 'a'; c <= 'z'; ++c) { ex_chars.push_back(c); }
    int different_chars = has_opt("c") ? opt<int>("c") : 2;
    vector<char> chars;
    for (int i = 0; i < different_chars; ++i) {
        int p = rnd.next(0, static_cast<int>(ex_chars.size()) - 1);
        chars.push_back(ex_chars[p]);
        ex_chars[p] = ex_chars.back();
        ex_chars.pop_back();
    }

    int max_m = has_opt("m") ? opt<int>("m") : 1000'000;
    int max_n = opt<int>("n");
    int n = (1 + rnd.wnext(max_n, 3)) / 2 * 2;
    int len = static_cast<int>(min(static_cast<ll>(max_str_len), static_cast<ll>(n) * static_cast<ll>(max_m)));
    int m = 1 + rnd.wnext(len / n, 3);

    printf("%d\n", n);

    int w = opt<int>("w");

    vector <string> ss(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            ss[i] += chars[rnd.wnext(2, w)];
        }
    }

    for (int i = 0; i < n; ++i) {
        printf("%s\n", ss[i].c_str());
    }
}
