#include <bits/stdc++.h>

using namespace std;

void fast_io() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
}

struct node {
    node *l = nullptr, *r = nullptr;
    int val = -1;
};

int c;
node *root = new node();
int timer = 0;

inline void paint(const string& path, int c_i) {
    auto it = root;
    for (auto i : path) {
        if (i == 'L') {
            if (!it->l) {
                it->l = new node();
            }
            it = it->l;
        } else {
            if (!it->r) {
                it->r = new node();
            }
            it = it->r;
        }
    }
    it->val = c_i;
}

inline int get_c(const string& path) {
    int res = -1;
    auto it = root;
    for (auto i : path) {
        if (i == 'L') {
            if (!it->l) {
                it->l = new node();
            }
            if (res != -1) {
                res = (res + 1) % c; 
            }
            it = it->l;
        } else {
            if (!it->r) {
                it->r = new node();
            }
            if (res != -1) {
                res = (res + c - 1) % c; 
            }
            it = it->r;
        }
        if (it->val != -1) {
            res = it->val;
        }
    }
    return res;
}

signed main() {
    fast_io();
    int q, t, c_i;
    cin >> q >> c;
    string path;
    for (int i = 0; i < q; ++i) {
        ++timer; 
        cin >> t;
        if (t == 1) {
            cin >> c_i;
        }
        cin >> path;
        if (t == 1) {
            paint(path, c_i);
        } else {
            cout << get_c(path) << '\n';
        }
    }
    return 0;
}